<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:template match="/">
		<genenetobjecttype>
			<xsl:attribute name="type">
				<xsl:choose>
					<xsl:when test="/rowset/row/type ='user'">-1</xsl:when>
					<xsl:when test="/rowset/row/type ='diagram'">0</xsl:when>
					<xsl:when test="/rowset/row/type ='compartment'">1</xsl:when>
					<xsl:when test="/rowset/row/type ='process'">2</xsl:when>
					<xsl:when test="/rowset/row/type ='protein'">3</xsl:when>
					<xsl:when test="/rowset/row/type ='reaction'">4</xsl:when>
					<xsl:when test="/rowset/row/type ='gene'">5</xsl:when>
					<xsl:when test="/rowset/row/type ='rna'">6</xsl:when>
					<xsl:when test="/rowset/row/type ='substance'">7</xsl:when>
				</xsl:choose>
			</xsl:attribute>
			<xsl:attribute name="multiple">
			        <xsl:choose>
				        <xsl:when test="/rowset/row/type ='user'">no</xsl:when>
				        <xsl:when test="/rowset/row/type ='diagram'">no</xsl:when>
				        <xsl:when test="/rowset/row/type ='compartment'">no</xsl:when>
				        <xsl:when test="/rowset/row/type ='process'">no</xsl:when>
				        <xsl:when test="/rowset/row/type ='protein'">yes</xsl:when>
				        <xsl:when test="/rowset/row/type ='reaction'">no</xsl:when>
				        <xsl:when test="/rowset/row/type ='gene'">yes</xsl:when>
				        <xsl:when test="/rowset/row/type ='rna'">yes</xsl:when>
				        <xsl:when test="/rowset/row/type ='substance'">no</xsl:when>
				</xsl:choose>
			</xsl:attribute>
			<xsl:attribute name="name"><xsl:value-of select="/rowset/row/type"/></xsl:attribute>
			<properties>
			    <xsl:for-each select = "/rowset/row">
				<xsl:sort select="id" data-type="string" />
				<property>
				    <xsl:attribute name="id"><xsl:value-of select="id"/></xsl:attribute>
				    <xsl:attribute name="description"><xsl:value-of select="description"/></xsl:attribute>
    				    <xsl:attribute name="volatile"><xsl:value-of select="volatile"/></xsl:attribute>
				    <xsl:attribute name="multiple"><xsl:value-of select="multiple"/></xsl:attribute>
				    <xsl:attribute name="required"><xsl:value-of select="required"/></xsl:attribute>
				    <xsl:attribute name="rule"><xsl:value-of select="rule"/></xsl:attribute>
				    <xsl:attribute name="default"><xsl:value-of select="default"/></xsl:attribute>
				    <xsl:attribute name="generic"><xsl:value-of select="generic"/></xsl:attribute>
				    <xsl:attribute name="updateable"><xsl:value-of select="updateable"/></xsl:attribute>
				</property>
			    </xsl:for-each>
			</properties>
		</genenetobjecttype>
	</xsl:template>
</xsl:stylesheet>
