<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
                xmlns:msxsl="urn:schemas-microsoft-com:xslt" 
						 xmlns:protein="http://wwwmgs.bionet.nsc.ru/proteinnamespace"
						 xmlns:gene="http://wwwmgs.bionet.nsc.ru/genenamespace"
						 xmlns:rna="http://wwwmgs.bionet.nsc.ru/rnanamespace"
						 xmlns:reaction="http://wwwmgs.bionet.nsc.ru/reactionnamespace"
						 version="1.0">

	<msxsl:script language="JScript" implements-prefix="protein">
		function NM(nodelist) 
			{
			node = nodelist.nextNode();
			
			var name = "";

			// взять короткое имя протеина 
			sn = node.selectSingleNode("object/sn");
			if (sn)
				name = sn.text;
			else
				{
				// короткое имя не определено - добавим полное
				nm = node.selectSingleNode("object/nm");
				if (nm)
					name = nm.text;
				}
				
   		var osn = "";
			
			// определить сокращенные имена всех организмов
			oss = node.selectNodes("object/os/latin"); // их может быть много (группа эквивалентности)
			for (j = 0; j &lt; oss.length; j++)
				{
				os = oss.item(j);
				
				if (os)
					{
					ost = os.text;
					
					// отбрасывается общепринятое название организма (в скобках)
					n = ost.indexOf("(");
					if (n != -1)
						ost = ost.substr(0, n);
	
					// разбить на куски по пробелу
					ss = ost.split(" ");
					ost = "";
					for (i = 0; i &lt; ss.length; i++)
						ost += ss[i].charAt(0);
												
					}
					
				if (j > 0)
					osn += ",";
				
				osn += ost;
				}
				
			if (osn != "")
				name += "(" + osn + ")";

	   	return name;
	    	}

		function ONM(nodelist) 
			{
			node = nodelist.nextNode();
			
			var name = "";

			sn = node.selectSingleNode("sn");
			if (sn)
				name = sn.text;
			else
				{
				nm = node.selectSingleNode("nm");
				if (nm)
					name = nm.text;
				}
				
   		var osn = "";
			
			os = node.selectSingleNode("os/latin"); 
				
				if (os)
					{
					osn = os.text;
					
					n = osn.indexOf("(");
					if (n != -1)
						osn = osn.substr(0, n);
	
					ss = osn.split(" ");
					osn = "";
					for (i = 0; i &lt; ss.length; i++)
						osn += ss[i].charAt(0);
												
					}
					
				
			if (osn != "")
				name = osn + ":" + name;

	   	return name;
	    	}
	
	</msxsl:script>

	<msxsl:script language="JScript" implements-prefix="gene">
		function NM(nodelist) 
			{
			node = nodelist.nextNode();
			
			var name = "";

			// взять короткое имя
			sn = node.selectSingleNode("object/sn");
			if (sn)
				name = sn.text;
			else
				{
				// короткое имя не определено - добавим полное
				nm = node.selectSingleNode("object/nm");
				if (nm)
					name = nm.text;
				}
				
   		var osn = "";
			
			// определить сокращенные имена всех организмов
			oss = node.selectNodes("object/os/latin"); // их может быть много (группа эквивалентности)
			for (j = 0; j &lt; oss.length; j++)
				{
				os = oss.item(j);
				
				if (os)
					{
					ost = os.text;
					
					// отбрасывается общепринятое название организма (в скобках)
					n = ost.indexOf("(");
					if (n != -1)
						ost = ost.substr(0, n);
	
					// разбить на куски по пробелу
					ss = ost.split(" ");
					ost = "";
					for (i = 0; i &lt; ss.length; i++)
						ost += ss[i].charAt(0);
												
					}
					
				if (j > 0)
					osn += ",";
				
				osn += ost;
				}
				
			if (osn != "")
				name += "(" + osn + ")";

	   	return name;
	    	}
	
	</msxsl:script>

	<msxsl:script language="JScript" implements-prefix="rna">
		function NM(nodelist) 
			{
			node = nodelist.nextNode();
			
			var name = "";

			// взять короткое имя
			sn = node.selectSingleNode("object/sn");
			if (sn)
				name = sn.text;
			else
				{
				// короткое имя не определено - добавим полное
				nm = node.selectSingleNode("object/nm");
				if (nm)
					name = nm.text;
				}
				
   		var osn = "";
			
			// определить сокращенные имена всех организмов
			oss = node.selectNodes("object/os/latin"); // их может быть много (группа эквивалентности)
			for (j = 0; j &lt; oss.length; j++)
				{
				os = oss.item(j);
				
				if (os)
					{
					ost = os.text;
					
					// отбрасывается общепринятое название организма (в скобках)
					n = ost.indexOf("(");
					if (n != -1)
						ost = ost.substr(0, n);
	
					// разбить на куски по пробелу
					ss = ost.split(" ");
					ost = "";
					for (i = 0; i &lt; ss.length; i++)
						ost += ss[i].charAt(0);
												
					}
					
				if (j > 0)
					osn += ",";
				
				osn += ost;
				}
				
			if (osn != "")
				name += "(" + osn + ")";

	   	return name;
	    	}
	
	</msxsl:script>

	<xsl:template match="/">
		<tree>
			<xsl:apply-templates select="/diagram"/> <!-- обработать схему -->
		</tree>
	</xsl:template>
	
 	<xsl:template match="diagram">
		<!--    Cхемa    -->
		<node type="0" class="diagram" > 
			<!-- атрибуты схемы -->
			<xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
			<xsl:attribute name="name"><xsl:value-of select="name"/></xsl:attribute>
			<xsl:if test="expanded[.='true']"><xsl:attribute name="expanded">true</xsl:attribute></xsl:if>
			
			<!-- название схемы -->
			<xsl:if test="ac">
				<xsl:attribute name="title"><xsl:value-of select="ac"/></xsl:attribute>
			</xsl:if>
			
			<xsl:apply-templates select="objects/compartment" /> <!-- обработать все вложенные компартменты -->
			<xsl:apply-templates select="objects/protein" /> <!-- обработать все вложенные протеины -->
			<xsl:apply-templates select="objects/gene" /> <!-- обработать все вложенные гены -->
			<xsl:apply-templates select="objects/operon" /> <!-- обработать все вложенные гены -->			
			<xsl:apply-templates select="objects/rna" /> <!-- обработать все вложенные RNA -->
			<xsl:apply-templates select="objects/substance" /> <!-- обработать все вложенные субстанции -->
			<xsl:apply-templates select="objects/process" /> <!-- обработать все вложенные процессы -->
			<xsl:apply-templates select="objects/reaction" /> <!-- обработать все вложенные реакции -->
			
		</node>
	</xsl:template>
	
<!-- КОМПАРТМЕНТ ==========================================================================  -->
 	<xsl:template match="compartment">
		<node type="1" class="compartment" >
			<xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
			<xsl:if test="expanded[.='true']"><xsl:attribute name="expanded">true</xsl:attribute></xsl:if>
			
			<!-- название компартмента (если есть) -->
			<xsl:if test="object/ac">
				<xsl:attribute name="title"><xsl:value-of select="object/ac"/></xsl:attribute>
			</xsl:if>
			
			<xsl:apply-templates select="objects/compartment" /> <!-- обработать все вложенные компартменты -->
			<xsl:apply-templates select="objects/protein" /> <!-- обработать все вложенные протеины -->
			<xsl:apply-templates select="objects/gene" /> <!-- обработать все вложенные гены -->
			<xsl:apply-templates select="objects/operon" /> <!-- обработать все вложенные гены -->
			<xsl:apply-templates select="objects/rna" /> <!-- обработать все вложенные RNA -->
			<xsl:apply-templates select="objects/substance" /> <!-- обработать все вложенные субстанции -->
			<xsl:apply-templates select="objects/process" /> <!-- обработать все вложенные процессы -->
			<xsl:apply-templates select="objects/reaction" /> <!-- обработать все вложенные реакции -->
		
		</node>
	</xsl:template>


<!-- РЕАКЦИЯ ===========================================================================  -->
 	<xsl:template match="reaction">
		<xsl:variable name="rid" select="@id"/>
		<node type="4" class="object" >
			<xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
			<xsl:if test="expanded[.='true']"><xsl:attribute name="expanded">true</xsl:attribute></xsl:if>

			<!-- название -->
			<xsl:if test="object/nm">
				<xsl:attribute name="title"><xsl:value-of select="object/nm"/></xsl:attribute>
			</xsl:if>
			<node type="9" title="IN" class="source" > <!-- входные данные реакции -->
				<xsl:attribute name="id">in_<xsl:value-of select="@id"/></xsl:attribute>
				<xsl:for-each select="//links/link[@target=$rid]">
  					<xsl:variable name="srcid" select="@source" /> 
					<xsl:choose>
						<xsl:when test="name(//reaction[@id=$srcid])='reaction'">
  						        <node type="4" class="object" >
							<xsl:attribute name="id"><xsl:value-of select="$srcid"/></xsl:attribute>
							<xsl:if test="//reaction[@id=$srcid]/expanded[.='true']"><xsl:attribute name="expanded">true</xsl:attribute></xsl:if>

							<xsl:if test="//reaction[@id=$srcid]/object/nm">
								<xsl:attribute name="title"><xsl:value-of select="//reaction[@id=$srcid]/object/nm"/></xsl:attribute>
							</xsl:if>	
                                                        </node>
						</xsl:when>
          					<xsl:otherwise>
							<xsl:choose>
                                                        	<xsl:when test="@sourceoid">	
									<xsl:apply-templates select="//*[@id=$srcid]" >
										<xsl:with-param name="oid" select="@sourceoid"/>
                                                                        </xsl:apply-templates>
							        </xsl:when>
                                                                <xsl:otherwise>
                                                                	<xsl:apply-templates select="//*[@id=$srcid]" />
                                                                </xsl:otherwise>
                                                        </xsl:choose>
						</xsl:otherwise>
        				</xsl:choose>
				</xsl:for-each>
			</node>
			<node type="8" title="OUT" class="target" > <!-- выходные данные реакции -->
				<xsl:attribute name="id">out_<xsl:value-of select="@id"/></xsl:attribute>
				<xsl:for-each select="//links/link[@source=$rid]">
  					<xsl:variable name="tgtid" select="@target" /> 
					<xsl:choose>
						<xsl:when test="name(//reaction[@id=$tgtid])='reaction'">
  						        <node type="4" class="object" >
							<xsl:attribute name="id"><xsl:value-of select="$tgtid"/></xsl:attribute>
							<xsl:if test="//reaction[@id=$tgtid]/expanded[.='true']"><xsl:attribute name="expanded">true</xsl:attribute></xsl:if>

							<xsl:if test="//reaction[@id=$tgtid]/object/nm">
								<xsl:attribute name="title"><xsl:value-of select="//reaction[@id=$tgtid]/object/nm"/></xsl:attribute>
							</xsl:if>	
                                                        </node>
						</xsl:when>
          					<xsl:otherwise>
							<xsl:choose>
                                                        	<xsl:when test="@targetoid">	
									<xsl:apply-templates select="//*[@id=$tgtid]" >
										<xsl:with-param name="oid" select="@targetoid"/>
                                                                        </xsl:apply-templates>
							        </xsl:when>
                                                                <xsl:otherwise>
                                                                	<xsl:apply-templates select="//*[@id=$tgtid]" />
                                                                </xsl:otherwise>
                                                        </xsl:choose>
						</xsl:otherwise>
        				</xsl:choose>
				</xsl:for-each>
			</node>
		</node>
	</xsl:template>


<!-- ПРОЦЕСС ==========================================================================  -->
 	<xsl:template match="process">
		<node type="2" class="object" >
			<xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>

			<!-- название -->
			<xsl:if test="object/nm">
				<xsl:attribute name="title"><xsl:value-of select="object/nm"/></xsl:attribute>
			</xsl:if>

		</node>
	</xsl:template>


<!-- ПРОТЕИН ==========================================================================  -->
 	<xsl:template match="protein">
		<xsl:param name="oid" />
		<node type="3" class="object" >
			<xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
			
			<!-- название -->
			<xsl:choose>
                        <xsl:when test="$oid">
                        	<xsl:attribute name="title"><xsl:value-of select="protein:ONM(./object[@id=$oid])"/></xsl:attribute>
                        </xsl:when>
                        <xsl:otherwise>
				<xsl:attribute name="title"><xsl:value-of select="protein:NM(.)"/></xsl:attribute>
                        </xsl:otherwise>
                        </xsl:choose>
			
		</node>
	</xsl:template>
	
<!-- ГЕН ==========================================================================  -->
 	<xsl:template match="gene">
		<xsl:param name="oid" />
		<node type="5" class="object" >
			<xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
			
			<!-- название -->

			<xsl:choose>
                        <xsl:when test="$oid">
                        	<xsl:attribute name="title"><xsl:value-of select="protein:ONM(./object[@id=$oid])"/></xsl:attribute>
                        </xsl:when>
                        <xsl:otherwise>
				<xsl:attribute name="title"><xsl:value-of select="gene:NM(.)"/></xsl:attribute>
                        </xsl:otherwise>
                        </xsl:choose>
			
		</node>
	</xsl:template>
<!-- OPERON ==========================================================================  -->
 	<xsl:template match="operon">
		<xsl:param name="oid" />
		<node type="10" class="object" >
			<xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
			
			<!-- название -->

			<xsl:choose>
                        <xsl:when test="$oid">
                        	<xsl:attribute name="title"><xsl:value-of select="protein:ONM(./object[@id=$oid])"/></xsl:attribute>
                        </xsl:when>
                        <xsl:otherwise>
				<xsl:attribute name="title"><xsl:value-of select="gene:NM(.)"/></xsl:attribute>
                        </xsl:otherwise>
                        </xsl:choose>
			
		</node>
	</xsl:template>
	
<!-- RNA ==========================================================================  -->
 	<xsl:template match="rna">
		<xsl:param name="oid" />

		<node type="6" class="object" >
			<xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
			
			<!-- название -->
			<xsl:choose>
                        <xsl:when test="$oid">
                        	<xsl:attribute name="title"><xsl:value-of select="protein:ONM(./object[@id=$oid])"/></xsl:attribute>
                        </xsl:when>
                        <xsl:otherwise>
				<xsl:attribute name="title"><xsl:value-of select="rna:NM(.)"/></xsl:attribute>
                        </xsl:otherwise>
                        </xsl:choose>
			
		</node>
	</xsl:template>
	
<!-- СУБСТАНЦИЯ ==========================================================================  -->
 	<xsl:template match="substance">
		<node type="7" class="object" >
			<xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
			
			<!-- название -->
			<xsl:attribute name="title"><xsl:value-of select="object/nm"/></xsl:attribute>
			
		</node>
	</xsl:template>

<!-- СВЯЗЬ ==========================================================================  -->
	
</xsl:stylesheet>
