<xsl:stylesheet 	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
                	xmlns:msxsl="urn:schemas-microsoft-com:xslt" 
	             	xmlns:protein="http://wwwmgs.bionet.nsc.ru/proteinnamespace"
	             	xmlns:gene="http://wwwmgs.bionet.nsc.ru/genenamespace"
	             	xmlns:rna="http://wwwmgs.bionet.nsc.ru/rnanamespace"
  	           		xmlns:reaction="http://wwwmgs.bionet.nsc.ru/reactionnamespace"
             version="1.0">
            
  <msxsl:script language="JScript" implements-prefix="protein">
    <!-- определение цвета в зависимости от Functional state (поле fn) протеина -->
 
   function NM(nodelist) 
      {
      node = nodelist.nextNode();
      
      var name = "";

      // взять короткое имя протеина 
      sn = node.selectSingleNode("object/sn");
      SN = node.selectSingleNode("object/SN");

      if (SN)
        name = SN.text;
      else  if(sn)
        {
        name = sn.text;
        }
      else
        {
        // короткое имя не определено - добавим полное
        nm = node.selectSingleNode("object/nm");
        if (nm)
          name = nm.text;
        }
        
      var osn = "";
      
      // определить сокращенные имена всех организмов
      oss = node.selectNodes("object/os/latin"); // их может быть много (группа эквивалентности)
      for (j = 0; j &lt; oss.length; j++)
        {
        os = oss.item(j);
        
        if (os)
          {
          ost = os.text;
          
          // отбрасывается общепринятое название организма (в скобках)
          n = ost.indexOf("(");
          if (n != -1)
            ost = ost.substr(0, n);
  
          // разбить на куски по пробелу
          ss = ost.split(" ");
          ost = "";
          for (i = 0; i &lt; ss.length; i++)
            ost += ss[i].charAt(0);
                        
          }
          
        if (j > 0)
          osn += ",";
        
        osn += ost;
        }
        
      if (osn != "")
        name += " " + "(" + osn + ")";

      return name;
        }
  
  </msxsl:script>

  <msxsl:script language="JScript" implements-prefix="gene">
    function NM(nodelist) 
      {
      node = nodelist.nextNode();
      
      var name = "";

      // взять короткое имя 
      sn = node.selectSingleNode("object/sn");
      if (sn)
        name = sn.text;
      else
        {
        // короткое имя не определено - добавим полное
        nm = node.selectSingleNode("object/nm");
        if (nm)
          name = nm.text;
        }
        
      var osn = "";
      
      // определить сокращенные имена всех организмов
      oss = node.selectNodes("object/os/latin"); // их может быть много (группа эквивалентности)
      for (j = 0; j &lt; oss.length; j++)
        {
        os = oss.item(j);
        
        if (os)
          {
          ost = os.text;
          
          // отбрасывается общепринятое название организма (в скобках)
          n = ost.indexOf("(");
          if (n != -1)
            ost = ost.substr(0, n);
  
          // разбить на куски по пробелу
          ss = ost.split(" ");
          ost = "";
          for (i = 0; i &lt; ss.length; i++)
            ost += ss[i].charAt(0);
                        
          }
          
        if (j > 0)
          osn += ",";
        
        osn += ost;
        }
        
      if (osn != "")
        name += " " + "(" + osn + ")";

      return name;
      }
  
  </msxsl:script>

  <msxsl:script language="JScript" implements-prefix="rna">
    function NM(nodelist) 
      {
      node = nodelist.nextNode();
      
      var name = "";

      // взять короткое имя 
      sn = node.selectSingleNode("object/sn");
      if (sn)
        name = sn.text;
      else
        {
        // короткое имя не определено - добавим полное
        nm = node.selectSingleNode("object/nm");
        if (nm)
          name = nm.text;
        }
        
      var osn = "";
      
      // определить сокращенные имена всех организмов
      oss = node.selectNodes("object/os/latin"); // их может быть много (группа эквивалентности)
      for (j = 0; j &lt; oss.length; j++)
        {
        os = oss.item(j);
        
        if (os)
          {
          ost = os.text;
          
          // отбрасывается общепринятое название организма (в скобках)
          n = ost.indexOf("(");
          if (n != -1)
            ost = ost.substr(0, n);
  
          // разбить на куски по пробелу
          ss = ost.split(" ");
          ost = "";
          for (i = 0; i &lt; ss.length; i++)
            ost += ss[i].charAt(0);
                        
          }
          
        if (j > 0)
          osn += ",";
        
        osn += ost;
        }
        
      if (osn != "")
        name += " " + "(" + osn + ")";

      return name;
      }
  
  </msxsl:script>

    
	<xsl:template match="/diagram">
		<node>
			<xsl:attribute name="name"><xsl:value-of select="/diagram/name"/>::<xsl:value-of select="/diagram/ac"/></xsl:attribute>
			<xsl:attribute name="type"><xsl:value-of select="@type"/></xsl:attribute>
		</node>
		
	</xsl:template>

	<xsl:template match="/compartment">
		<node>
			<xsl:attribute name="name"><xsl:value-of select="object/ac"/></xsl:attribute>
                </node>
	</xsl:template>
	<xsl:template match="/process">
		<node>
			<xsl:attribute name="name"><xsl:value-of select="object/nm"/></xsl:attribute>
                </node>
	</xsl:template>
	<xsl:template match="/protein">
		<node>
			<xsl:attribute name="name"><xsl:value-of select="protein:NM(.)"/></xsl:attribute>
                </node>
	</xsl:template>
	<xsl:template match="/reaction">
		<node>
			<xsl:attribute name="name"><xsl:value-of select="object/nm"/></xsl:attribute>
                </node>
	</xsl:template>
	<xsl:template match="/gene">
		<node>
			<xsl:attribute name="name"><xsl:value-of select="gene:NM(.)"/></xsl:attribute>
                </node>
	</xsl:template>
	<xsl:template match="/rna">
		<node>
			<xsl:attribute name="name"><xsl:value-of select="rna:NM(.)"/></xsl:attribute>
                </node>
	</xsl:template>
	<xsl:template match="/substance">
		<node>
			<xsl:attribute name="name"><xsl:value-of select="object/nm"/></xsl:attribute>
                </node>
	</xsl:template>
	<xsl:template match="/os">
		<node>
			<xsl:attribute name="name"><xsl:value-of select="latin"/>::<xsl:value-of select="english"/></xsl:attribute>
                </node>
	</xsl:template>
	<xsl:template match="/operon">
		<node>
			<xsl:attribute name="name"><xsl:value-of select="gene:NM(.)"/></xsl:attribute>
                </node>
	</xsl:template>


</xsl:stylesheet>

