<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format"    
xmlns:msxsl="urn:schemas-microsoft-com:xslt" 
xmlns:object="http://wwwmgs.bionet.nsc.ru/genenamespace">

  <msxsl:script language="JScript" implements-prefix="object"><![CDATA[
  	function deleteReaction(nodelist)
  	{  		
  		var reaction = nodelist.nextNode();
  		return deleteReaction2(reaction);
  	}

	function deleteLink(nodelist)
	{
		var link = nodelist.nextNode();
		return deleteLink2(link);
	}

	function deleteLink2(m_link)
	{
		var target = m_link.getAttribute("target");
		var source = m_link.getAttribute("source");

		var targetobj = m_link.selectSingleNode("//reaction[@id='"+target+"']");
		if(targetobj)
		{
			if(deleteReaction2(targetobj) == "true")
			{
				return "true";
			}
		}
		
		var sourceobj = m_link.selectSingleNode("//reaction[@id='"+source+"']");
		if(sourceobj)
		{
			if(deleteReaction2(sourceobj) == "true")
			{
				return "true";
			}
		}			
		
		return "false";
		
	}

  	function deleteReaction2(m_reactionEl)
  	{
		var m_id = m_reactionEl.getAttribute("id");
		
		var nl = m_reactionEl.selectNodes("//link[@target='"+m_id+"']");
		for(i=0; i  < nl.length; i++)
		{
			var link = nl.item(i);
			
			var sourceoid = link.getAttribute("sourceoid");
			var source = link.getAttribute("source");
			
			if(sourceoid)
			{
				var sourceobj = m_reactionEl.selectSingleNode("//object[@id='"+sourceoid+"']");
				
				if(deleteObject2(sourceobj) == "true")
				{
					return "true";
				}
				
			}
		}
		
		
		nl = m_reactionEl.selectNodes("//link[@source='"+m_id+"']");
		for(i=0; i < nl.length; i++)
		{
			var link = nl.item(i);
			
			var targetoid = link.getAttribute("targetoid");
			var target = link.getAttribute("target");
			
						
			if(targetoid)
			{
				var targetobj = m_reactionEl.selectSingleNode("//object[@id='"+targetoid+"']");
				if(deleteObject2(targetobj) == "true")
				{
					return "true";
				}
			}
			
			var targetreaction = m_reactionEl.selectSingleNode("//reaction[@id='"+target+"']");
			if(targetreaction )
			{
				if(deleteReaction2(targetreaction) == "true")
				{
					return "true";
				}
			}

			

		}
  		return "false";
  	}
	
	
  	function deleteObject2(m_object)
  	{
  		var nl = m_object.ownerDocument.documentElement.selectNodes("//filter");
		
		for( j=0; j < nl.length; j++)
		{
		    var filterEl  = nl.item(j);
		    var filterID = filterEl.getAttribute("id");
  		
  		    if(m_object)
  		    {	
  			var m_repressors = m_object.selectNodes("repressor");
			
			for(h=0; h < m_repressors.length; h++)
			{                {			    
			    var m_repressor = m_repressors.item(h);
  			    var m_repressorID = m_repressor.getAttribute("id");
			    
  			    if(m_repressorID)
  			    {
	  		        if(filterID == m_repressorID)
	  		        {	
  			    	    return "false";
	  			}	
	  		    }	
			}	
  		    }
		}
  		return "true";
  	}  	
  	function deleteGRP(nodelist)
  	{
  		var grp = nodelist.nextNode();
		
		nl = grp.selectNodes("object");
		
		for( i=0; i < nl.length; i++)
		{
			obj = nl.item(i);
			
			if(deleteObject2(obj) == "false")
			{
				return "false";
			}
		} 		
		
  		return "true";
  	}  	

  	
  	function deleteObject(nodelist)
  	{
  		var obj = nodelist.nextNode();
  		return deleteObject2(obj);
  	}  	

  	
]]></msxsl:script>
  
	<xsl:template match="/diagram">
		<xsl:copy>
			<xsl:apply-templates select="@*"/>
			<xsl:apply-templates select="name|ac|color|bordercolor|expanded|x|y|nm|dt|width|height|r"/>
			<xsl:apply-templates select="objects"/>
			<xsl:apply-templates select="links"/>
		</xsl:copy>
	</xsl:template>
	<xsl:template match="compartment">
		<xsl:copy>
			<xsl:apply-templates select="@*"/>
			<xsl:apply-templates select="color|bordercolor|x|y|nm|dt|width|height|r|ac|cc|CC|ref"/>
			<xsl:for-each select="object">
				<xsl:copy>
					<xsl:apply-templates select="@*"/>
					<xsl:apply-templates select="ac|dt"/>
				</xsl:copy>
			</xsl:for-each>
			<xsl:apply-templates select="objects"/>
		</xsl:copy>
	</xsl:template>
	<xsl:template match="objects">
		<xsl:copy>
			<xsl:apply-templates select="@*"/>
			<xsl:apply-templates select="compartment|substance|process|gene|rna|protein|reaction"/>
		</xsl:copy>
	</xsl:template>
	<xsl:template match="substance">
		<xsl:copy-of select="."/>
	</xsl:template>
	<xsl:template match="process">
		<xsl:copy-of select="."/>
	</xsl:template>
	<xsl:template match="gene|rna|protein">
		<xsl:if test="object:deleteGRP(.)='false'">
			<xsl:copy>
				<xsl:apply-templates select="@*|x|y"/>
				<xsl:for-each select="object">
					<xsl:if test="object:deleteObject(.) = 'false'">
						<xsl:copy-of select="."/>
					</xsl:if>
				</xsl:for-each>
			</xsl:copy>
		</xsl:if>
	</xsl:template>
	<xsl:template match="width|height|ac|color|bordercolor|expanded|x|y|nm|dt|name|r|cc|CC">
		<xsl:copy>
			<xsl:apply-templates select="text()"/>
		</xsl:copy>
	</xsl:template>
	<xsl:template match="links">
		<xsl:copy>
			<xsl:apply-templates select="link[@sourceoid]"/>
			<xsl:apply-templates select="link[@targetoid]"/>
			<xsl:apply-templates select="link[not(@targetoid) and not(@sourceoid)]"/>
		</xsl:copy>
	</xsl:template>
	<xsl:template match="link">
		<xsl:if test="object:deleteLink(.) = 'false'">
			<xsl:copy-of select="."/>
		</xsl:if>
	</xsl:template>	
	<xsl:template match="reaction">
		<xsl:if test="object:deleteReaction(.) = 'false'">
			<xsl:copy-of select="."/>
		</xsl:if>
	</xsl:template>	
	<xsl:template match="ref">
		<xsl:copy-of select="."/>
	</xsl:template>
	<xsl:template match="@*">
		<xsl:copy/>
	</xsl:template>
	<xsl:template match="text()">
		<xsl:copy/>
	</xsl:template>
</xsl:stylesheet>
