<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
version="1.0">

	<xsl:template match="/diagram">
		<node>
			<xsl:attribute name="name"><xsl:value-of select="/diagram/name"/>::<xsl:value-of select="/diagram/ac"/></xsl:attribute>
			<xsl:attribute name="type"><xsl:value-of select="@type"/></xsl:attribute>
		</node>
		
	</xsl:template>

	<xsl:template match="/rowset/row">
		<node>
			<xsl:attribute name="name">
				<xsl:choose>
					<xsl:when test="type[.='compartments']"><xsl:value-of select="/rowset/row/ac"/></xsl:when>

					<xsl:when test="type[.='processes']"><xsl:value-of select="/rowset/row/nm"/></xsl:when>

					<xsl:when test="type[.='proteins']">
						<xsl:variable name="os"><xsl:value-of select="normalize-space(substring-before(/rowset/row/os,'('))"/></xsl:variable>
						<xsl:variable name="first"><xsl:value-of select="substring(substring-before($os,' '),1,1)"/></xsl:variable>
						<xsl:variable name="second"><xsl:value-of select="substring(substring-after($os,' '),1,1)"/></xsl:variable>
						<xsl:value-of select="concat($first,$second)"/>
						<xsl:if test="/rowset/row/sn"> : <xsl:value-of select="/rowset/row/sn"/></xsl:if>
						<xsl:if test="/rowset/row/nm"> : <xsl:value-of select="/rowset/row/nm"/></xsl:if>
						<xsl:for-each select="/rowset/row/sy"> : <xsl:value-of select="."/></xsl:for-each>
					</xsl:when>

					<xsl:when test="type[.='reactions']"><xsl:value-of select="/rowset/row/nm"/></xsl:when>

					<xsl:when test="type[.='genes']"><xsl:value-of select="/rowset/row/nm"/></xsl:when>

					<xsl:when test="type[.='rnas']"><xsl:value-of select="/rowset/row/nm"/></xsl:when>

					<xsl:when test="type[.='substances']"><xsl:value-of select="/rowset/row/nm"/></xsl:when>
					
					<xsl:when test="type[.='users']"><xsl:value-of select="/rowset/row/name"/></xsl:when>
				</xsl:choose>
			</xsl:attribute>
			<xsl:attribute name="type"><xsl:value-of select="@type"/></xsl:attribute>
		</node>
		
	</xsl:template>
						
</xsl:stylesheet>
