<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="xml" version="1.0" encoding="iso8859-1" indent="yes"/>


	<xsl:template match="/">
		
	<cpnet>
		<generator tool="Design/CPN" version="4.0.5"/>
		<xsl:apply-templates select="diagram"/>
	</cpnet>		
	</xsl:template>

<xsl:template match="diagram">
		<page>
		<xsl:variable name="hi"><xsl:value-of select="@height div 6"/></xsl:variable>
		<xsl:variable name="wi"><xsl:value-of select="@width div 6"/></xsl:variable>


			<xsl:attribute name="id"><xsl:value-of select="generate-id(current())"/></xsl:attribute>
			<pageattr>
			<xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
			<xsl:attribute name="number">1</xsl:attribute>
			<xsl:attribute name="visbor">true</xsl:attribute>
			<xsl:attribute name="palette">false</xsl:attribute>
			</pageattr>
			<mult insts="0"/>
			<modeattr siminc="false" observe="false" propocc="false" interact="false" execcode="false"/>
			<winattr open="true" width="723" height="577" xpos="0" ypos="0"/>
			<lineattr type="solid" thick="0" colour="black"/>
			<fillattr pattern="none" colour="black"/>
			<posattr>
				<xsl:attribute name="x"><xsl:value-of select="(@x + $wi)div 3"/></xsl:attribute>
				<xsl:attribute name="y"><xsl:value-of select="(@y + $hi)div 3"/></xsl:attribute>				
			</posattr>
			<box>
				<xsl:attribute name="h"><xsl:value-of select="@height div 3"/></xsl:attribute>
				<xsl:attribute name="w"><xsl:value-of select="@width div 3"/></xsl:attribute>				
			</box>
			<xsl:apply-templates select="object[@type='protein'] | object[@type='substance'] | object[@type='process'] | object[@type='compartment'] | object[@type='gene'] | object[@type='operon'] | object[@type='rna'] | object[@type='regulatory event'] | object[@type='reaction'] | object[@type='fiction'] | links/link"/>
	</page>
</xsl:template>


<xsl:template match="object[@type='protein']">
				<xsl:variable name="hi"><xsl:value-of select="//@height div 6"/></xsl:variable>
				<xsl:variable name="wi"><xsl:value-of select="//@width div 6"/></xsl:variable>
			<place>
				<xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
				<flags mask="false" omit="false" nobound="false" nosizing="false" visible="true"/>
				<lineattr type="solid" thick="0" colour="black"/>
				<fillattr pattern="solid" colour="Green"/>
				<posattr >
				<xsl:attribute name="x"><xsl:value-of select="((@x)div 3)-($wi)"/></xsl:attribute>
				<xsl:attribute name="y"><xsl:value-of select="((@y)div 3)-($hi)"/></xsl:attribute>				
				</posattr>
				<textattr font="helvetica" size="10" just="centered" colour="black" bold="true" italic="false" underlin="false" outline="false" shadow="false" condense="false" extend="false" scbar="true"/>
				<ellipse h="10.58333" w="21.16667"/>
				<layering type="copy"/>
				<text>Protein: <xsl:value-of select="@name"/></text>
			</place>
</xsl:template>

			
<xsl:template match="object[@type='fiction']">
				<xsl:variable name="hi"><xsl:value-of select="//@height div 6"/></xsl:variable>
				<xsl:variable name="wi"><xsl:value-of select="//@width div 6"/></xsl:variable>
			<place>
				<xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
				<flags mask="false" omit="false" nobound="false" nosizing="false" visible="true"/>
				<lineattr type="Dash" thick="1" colour="black"/>
				<fillattr pattern="solid" colour="red"/>
				<posattr >
				<xsl:attribute name="x"><xsl:value-of select="@x div 3"/></xsl:attribute>
				<xsl:attribute name="y"><xsl:value-of select="@y div 3"/></xsl:attribute>				
				</posattr>
				<textattr font="helvetica" size="10" just="centered" colour="black" bold="false" italic="false" underlin="false" outline="false" shadow="false" condense="false" extend="false" scbar="true"/>
				<ellipse h="10.58333" w="21.16667"/>
				<layering type="copy"/>
				<text>fiction</text>
			</place>
</xsl:template>

<xsl:template match="object[@type='substance']">
				<xsl:variable name="hi"><xsl:value-of select="//@height div 6"/></xsl:variable>
				<xsl:variable name="wi"><xsl:value-of select="//@width div 6"/></xsl:variable>
				<xsl:variable name="y"><xsl:value-of select="((@y)div 3)-($hi)"/></xsl:variable>
				<xsl:variable name="x"><xsl:value-of select="((@x)div 3)-($wi)"/></xsl:variable>
			<place>
				<xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
				<flags mask="false" omit="false" nobound="false" nosizing="false" visible="true"/>
				<lineattr type="solid" thick="0" colour="black"/>
				<fillattr pattern="solid" colour="blue"/>
				<posattr >
				<xsl:attribute name="x"><xsl:value-of select="$x"/></xsl:attribute>
				<xsl:attribute name="y"><xsl:value-of select="$y"/></xsl:attribute>				
				</posattr>
				<textattr font="helvetica" size="10" just="centered" colour="black" bold="true" italic="false" underlin="false" outline="false" shadow="false" condense="false" extend="false" scbar="true"/>
				<ellipse h="10.58333" w="21.16667"/>
				<layering type="copy"/>
				<text><xsl:value-of select="@name"/></text>
			</place>
</xsl:template>

<xsl:template match="object[@type='rna']">
				<xsl:variable name="hi"><xsl:value-of select="//@height div 6"/></xsl:variable>
				<xsl:variable name="wi"><xsl:value-of select="//@width div 6"/></xsl:variable>
			<place>
				<xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
				<flags mask="false" omit="false" nobound="false" nosizing="false" visible="true"/>
				<lineattr type="solid" thick="0" colour="black"/>
				<fillattr pattern="none" colour="black"/>
				<posattr >
				<xsl:attribute name="x"><xsl:value-of select="((@x)div 3)-($wi)"/></xsl:attribute>
				<xsl:attribute name="y"><xsl:value-of select="((@y)div 3)-($hi)"/></xsl:attribute>				
				</posattr>
				<textattr font="helvetica" size="10" just="centered" colour="black" bold="true" italic="false" underlin="false" outline="false" shadow="false" condense="false" extend="false" scbar="true"/>
				<ellipse h="10.58333" w="21.16667"/>
				<layering type="copy"/>
				<text><xsl:value-of select="@name"/></text>
			</place>
</xsl:template>

<xsl:template match="object[@type='process']">
				<xsl:variable name="hi"><xsl:value-of select="//@height div 6"/></xsl:variable>
				<xsl:variable name="wi"><xsl:value-of select="//@width div 6"/></xsl:variable>
			<place>
				<xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
				<flags mask="false" omit="false" nobound="false" nosizing="false" visible="true"/>
				<lineattr type="solid" thick="0" colour="black"/>
				<fillattr pattern="none" colour="black"/>
				<posattr >
				<xsl:attribute name="x"><xsl:value-of select="((@x)div 3)-($wi)"/></xsl:attribute>
				<xsl:attribute name="y"><xsl:value-of select="((@y)div 3)-($hi)"/></xsl:attribute>				
				</posattr>
				<textattr font="helvetica" size="10" just="centered" colour="black" bold="true" italic="false" underlin="false" outline="false" shadow="false" condense="false" extend="false" scbar="true"/>
				<ellipse h="10.58333" w="21.16667"/>
				<layering type="copy"/>
				<text><xsl:value-of select="@name"/></text>
			</place>
</xsl:template>

<xsl:template match="object[@type='compartment']">
				<xsl:variable name="hi"><xsl:value-of select="//@height div 6"/></xsl:variable>
				<xsl:variable name="wi"><xsl:value-of select="//@width div 6"/></xsl:variable>
			<place>
				<xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
				<flags mask="false" omit="false" nobound="false" nosizing="false" visible="true"/>
				<lineattr type="solid" thick="0" colour="black"/>
				<fillattr pattern="none" colour="black"/>
				<posattr >
				<xsl:attribute name="x"><xsl:value-of select="((@x)div 3)-($wi)"/></xsl:attribute>
				<xsl:attribute name="y"><xsl:value-of select="((@y)div 3)-($hi)"/></xsl:attribute>				
				</posattr>
				<textattr font="helvetica" size="10" just="centered" colour="black" bold="true" italic="false" underlin="false" outline="false" shadow="false" condense="false" extend="false" scbar="true"/>
				<ellipse h="10.58333" w="21.16667"/>
				<layering type="copy"/>
				<text><xsl:value-of select="@name"/></text>
			</place>
</xsl:template>

<xsl:template match="object[@type='gene']">
				<xsl:variable name="hi"><xsl:value-of select="//@height div 6"/></xsl:variable>
				<xsl:variable name="wi"><xsl:value-of select="//@width div 6"/></xsl:variable>
			<place>
				<xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
				<flags mask="false" omit="false" nobound="false" nosizing="false" visible="true"/>
				<lineattr type="solid" thick="0" colour="black"/>
				<fillattr pattern="solid" colour="lime"/>
				<posattr >
				<xsl:attribute name="x"><xsl:value-of select="((@x)div 3)-($wi)"/></xsl:attribute>
				<xsl:attribute name="y"><xsl:value-of select="((@y)div 3)-($hi)"/></xsl:attribute>				
				</posattr>
				<textattr font="helvetica" size="10" just="centered" colour="black" bold="true" italic="false" underlin="false" outline="false" shadow="false" condense="false" extend="false" scbar="true"/>
				<ellipse h="10.58333" w="21.16667"/>
				<layering type="copy"/>
				<text><xsl:value-of select="@name"/></text>
			</place>
</xsl:template>

<xsl:template match="oobject[@type='operon']">
				<xsl:variable name="hi"><xsl:value-of select="//@height div 6"/></xsl:variable>
				<xsl:variable name="wi"><xsl:value-of select="//@width div 6"/></xsl:variable>
			<place>
				<xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
				<flags mask="false" omit="false" nobound="false" nosizing="false" visible="true"/>
				<lineattr type="solid" thick="0" colour="black"/>
				<fillattr pattern="solid" colour="yellow"/>
				<posattr >
				<xsl:attribute name="x"><xsl:value-of select="((@x)div 3)-($wi)"/></xsl:attribute>
				<xsl:attribute name="y"><xsl:value-of select="((@y)div 3)-($hi)"/></xsl:attribute>				
				</posattr>
				<textattr font="helvetica" size="10" just="centered" colour="black" bold="true" italic="false" underlin="false" outline="false" shadow="false" condense="false" extend="false" scbar="true"/>
				<ellipse h="10.58333" w="21.16667"/>
				<layering type="copy"/>
				<text><xsl:value-of select="@name"/></text>
			</place>
</xsl:template>

<xsl:template match="object[@type='regulatory event']">
				<xsl:variable name="hi"><xsl:value-of select="//@height div 6"/></xsl:variable>
				<xsl:variable name="wi"><xsl:value-of select="//@width div 6"/></xsl:variable>
<trans>
				<xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
				<flags mask="false" omit="false" nobound="false" nosizing="false" visible="true"/>
				<lineattr type="solid" thick="0" colour="black"/>
				<fillattr pattern="none" colour="black"/>
				<posattr>
				<xsl:attribute name="x"><xsl:value-of select="((@x)div 3)-($wi)"/></xsl:attribute>
				<xsl:attribute name="y"><xsl:value-of select="((@y)div 3)-($hi)"/></xsl:attribute>				
				</posattr>
				<textattr font="helvetica" size="10" just="centered" colour="black" bold="true" italic="false" underlin="false" outline="false" shadow="false" condense="false" extend="false" scbar="true"/>
				<box h="10.58333" w="21.16667"/>
				<layering type="copy"/>
				<text><xsl:value-of select="@state"/></text>
</trans>
</xsl:template>

<xsl:template match="object[@type='reaction']">
				<xsl:variable name="hi"><xsl:value-of select="//@height div 6"/></xsl:variable>
				<xsl:variable name="wi"><xsl:value-of select="//@width div 6"/></xsl:variable>
<trans>
				<xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
				<flags mask="false" omit="false" nobound="false" nosizing="false" visible="true"/>
				<lineattr type="solid" thick="0" colour="black"/>
				<fillattr pattern="none" colour="black"/>
				<posattr>
				<xsl:attribute name="x"><xsl:value-of select="((@x)div 3)-($wi)"/></xsl:attribute>
				<xsl:attribute name="y"><xsl:value-of select="((@y)div 3)-($hi)"/></xsl:attribute>				
				</posattr>
				<textattr font="helvetica" size="10" just="centered" colour="black" bold="true" italic="false" underlin="false" outline="false" shadow="false" condense="false" extend="false" scbar="true"/>
				<box h="10.58333" w="21.16667"/>
				<layering type="copy"/>
				<text><xsl:value-of select="@state"/></text>
</trans>
</xsl:template>


<xsl:template match="links/link">
	<xsl:variable name="sid"><xsl:value-of select="@source"/></xsl:variable>
	<xsl:variable name="tid"><xsl:value-of select="@target"/></xsl:variable>

			<arc>
		<xsl:attribute name="id"><xsl:value-of select="generate-id(current())"/></xsl:attribute>	
		
		<xsl:for-each select="//object[@id=$sid]">
		<xsl:choose>
			<xsl:when test="@type='regulatory event' or @type='reaction'"><xsl:attribute name="orientation">TtoP</xsl:attribute>
				<placeend><xsl:attribute name="idref"><xsl:value-of select="($tid)"/></xsl:attribute></placeend>
				<transend><xsl:attribute name="idref"><xsl:value-of select="($sid)"/></xsl:attribute></transend>
			</xsl:when>
			<xsl:otherwise><xsl:attribute name="orientation">PtoT</xsl:attribute>
				<placeend><xsl:attribute name="idref"><xsl:value-of select="($sid)"/></xsl:attribute></placeend>
				<transend><xsl:attribute name="idref"><xsl:value-of select="($tid)"/></xsl:attribute></transend>
			</xsl:otherwise>
		</xsl:choose>
		</xsl:for-each>
		
				<connattr hdwidth="4" hdheight="8" txtwidth="64" txtheight="32"/>
				<flags mask="false" omit="false" nobound="false" nosizing="false" visible="true"/>
				<lineattr type="solid" thick="2" colour="black"/>
				<fillattr pattern="solid" colour="black"/>
				<textattr font="helvetica" size="9" just="centered" colour="black" bold="false" italic="false" underlin="false" outline="false" shadow="false" condense="false" extend="false" scbar="true"/>
				<seg-conn curv="15" points=""/>
				<layering type="copy"/>
<!--					<xsl:choose>
						<xsl:when test="@orientation='PtoT'">
							<placeend><xsl:attribute name="idref"><xsl:value-of select="@source"/></xsl:attribute></placeend>
							<transend><xsl:attribute name="idref"><xsl:value-of select="@target"/></xsl:attribute></transend>
						</xsl:when>
						<xsl:when test="@orientation='TtoP'">
							<placeend><xsl:attribute name="idref"><xsl:value-of select="@target"/></xsl:attribute></placeend>
							<transend><xsl:attribute name="idref"><xsl:value-of select="@source"/></xsl:attribute></transend>
						</xsl:when>
					</xsl:choose>
		-->	</arc>
</xsl:template>

</xsl:stylesheet>
