<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet 	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
                	xmlns:msxsl="urn:schemas-microsoft-com:xslt" 
					 	xmlns:compartment="http://wwwmgs.bionet.nsc.ru/compartmentnamespace"
						version="1.0">

	<xsl:template match="/protein">
	    <protein>
		<xsl:apply-templates select="object"/>


			
	    </protein>
	</xsl:template>
	
	
	
    <xsl:template match="object">

		<xsl:for-each select="half-life">
		    <half-life>
			<xsl:attribute name="invalid">
			    <xsl:value-of select="boolean(string-length(value/text()) = 0)"/>
			</xsl:attribute>
		    </half-life>
		</xsl:for-each>

		<xsl:for-each select="Modification_site">
		    <Modification_site>
			<xsl:attribute name="invalid">
			    <xsl:value-of select="boolean(string-length(Site_name/text()) = 0) or boolean(string-length(State/text()) = 0)"/>
			</xsl:attribute>
	    <xsl:for-each select="local_comment_item">
	    	    <xsl:attribute name="invalid">
	        	<xsl:choose>
	            	    <xsl:when test="boolean(ref)">
	            		<xsl:value-of select="boolean(boolean(string-length(CC/text()) = 0) or not(boolean(ref/@id)))"/>
		    	    </xsl:when>
			    <xsl:otherwise>
				<xsl:value-of select="boolean(string-length(CC/text()) = 0)"/>
			    </xsl:otherwise>
			</xsl:choose>
	    	    </xsl:attribute>
	    </xsl:for-each>
			
		    </Modification_site>
		</xsl:for-each>

	    <xsl:for-each select="local_comment_item">
        	<local_comment_item>
	    	    <xsl:attribute name="invalid">
	        	<xsl:choose>
	            	    <xsl:when test="boolean(ref)">
	            		<xsl:value-of select="boolean(boolean(string-length(CC/text()) = 0) or not(boolean(ref/@id)))"/>
		    	    </xsl:when>
			    <xsl:otherwise>
				<xsl:value-of select="boolean(string-length(CC/text()) = 0)"/>
			    </xsl:otherwise>
			</xsl:choose>
	    	    </xsl:attribute>
		</local_comment_item>
	    </xsl:for-each>

	<xsl:for-each select="subunit">	
	    <subunit>
		<xsl:attribute name="invalid">
		    <xsl:value-of select="boolean(string-length(name/text()) = 0)"/>
		</xsl:attribute>		
	    </subunit>
	</xsl:for-each>

	
	<nm>
	    <xsl:attribute name="invalid">
		<xsl:value-of select="boolean(string-length(nm/text()) = 0)"/>
	    </xsl:attribute>
	</nm>

	<sn>
	    <xsl:attribute name="invalid">
		<xsl:value-of select="boolean(string-length(sn/text()) = 0)"/>
	    </xsl:attribute>
	</sn>

	<xsl:for-each select="dbref">
	<dbref>
	    <xsl:attribute name="invalid">
		<xsl:value-of select="boolean(string-length(name/text()) = 0) or boolean(string-length(ac/text()) = 0)"/>
	    </xsl:attribute>
	    
	    <xsl:if test="id">
		<xsl:attribute name="invalid">
		    <xsl:value-of select="boolean(string-length(id/text()) = 0)"/>
		</xsl:attribute>		
	    </xsl:if>
	    
	</dbref>
	</xsl:for-each>


	<xsl:for-each select="enzymeclass">
	    <enzymeclass>
		<xsl:attribute name="invalid">
		    <xsl:value-of select="boolean(string-length(./text()) = 0)"/>
		</xsl:attribute>		
	    </enzymeclass>
	</xsl:for-each>
	
	<xsl:if test="./fn">
	    <fn>
		<xsl:attribute name="invalid">
		    <xsl:value-of select="boolean(string-length(fn/text()) = 0)"/>
		</xsl:attribute>		
	    </fn>
	</xsl:if>

	<xsl:if test="./mm">
	    <mm>
		<xsl:attribute name="invalid">
		    <xsl:value-of select="boolean(string-length(mm/text()) = 0)"/>
		</xsl:attribute>		
	    </mm>
	</xsl:if>

	<xsl:if test="./md">
	    <md>
		<xsl:attribute name="invalid">
		    <xsl:value-of select="boolean(string-length(md/text()) = 0)"/>
		</xsl:attribute>		
	    </md>
	</xsl:if>

	<xsl:for-each select="sy">	
	    <sy>
		<xsl:attribute name="invalid">
		    <xsl:value-of select="boolean(string-length(./text()) = 0) or boolean(./text() = ../sn/text())  or boolean(./text() = ../nm/text())"/>
		</xsl:attribute>		
	    </sy>
	</xsl:for-each>

	<xsl:for-each select="total_comment_item">
            <total_comment_item>
	        <xsl:attribute name="invalid">
	            <xsl:choose>
	                <xsl:when test="boolean(ref)">
	            	    <xsl:value-of select="boolean(boolean(string-length(cc/text()) = 0) or not(boolean(ref/@id)))"/>
		        </xsl:when>
			<xsl:otherwise>
			    <xsl:value-of select="boolean(string-length(cc/text()) = 0)"/>
			</xsl:otherwise>
		    </xsl:choose>
	        </xsl:attribute>
	    </total_comment_item>
	</xsl:for-each>

	<xsl:choose>
            <xsl:when test="boolean(ref)">
	        <xsl:for-each select="ref">
	            <ref>
	                <xsl:attribute name="invalid">
	                    <xsl:value-of select="not(boolean(@id))"/>
	                </xsl:attribute>
	            </ref>
	        </xsl:for-each>
	    </xsl:when>
	    <xsl:otherwise><ref invalid="true"/></xsl:otherwise>
	</xsl:choose>	
	

    </xsl:template>

</xsl:stylesheet>
